package cofh.thermal.expansion.compat.jei.machine;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cofh.core.util.helpers.ItemHelper;
import cofh.core.util.helpers.RenderHelper;
import cofh.lib.util.helpers.StringHelper;
import cofh.thermal.core.ThermalCore;
import cofh.thermal.core.compat.jei.TCoreJeiPlugin;
import cofh.thermal.core.util.recipes.machine.PressRecipe;
import cofh.thermal.expansion.client.gui.machine.MachinePressScreen;
import cofh.thermal.lib.compat.jei.Drawables;
import cofh.thermal.lib.compat.jei.ThermalRecipeCategory;
import cofh.thermal.lib.util.recipes.ThermalRecipe;
import com.mojang.blaze3d.vertex.PoseStack;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import mezz.jei.api.forge.ForgeTypes;
import mezz.jei.api.gui.builder.IRecipeLayoutBuilder;
import mezz.jei.api.gui.builder.IRecipeSlotBuilder;
import mezz.jei.api.gui.drawable.IDrawable;
import mezz.jei.api.gui.drawable.IDrawableAnimated;
import mezz.jei.api.gui.drawable.IDrawableStatic;
import mezz.jei.api.gui.ingredient.IRecipeSlotsView;
import mezz.jei.api.helpers.IGuiHelper;
import mezz.jei.api.ingredients.IIngredientType;
import mezz.jei.api.recipe.IFocusGroup;
import mezz.jei.api.recipe.RecipeIngredientRole;
import net.minecraft.network.chat.Component;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.level.block.Block;
import net.minecraftforge.fluids.FluidStack;

public class PressRecipeCategory extends ThermalRecipeCategory<PressRecipe> {
  protected IDrawableStatic tankBackground;
  
  protected IDrawableStatic tankOverlay;
  
  public PressRecipeCategory(IGuiHelper guiHelper, ItemStack icon, ResourceLocation uid) {
    super(guiHelper, icon, uid);
    this
      
      .background = (IDrawable)guiHelper.drawableBuilder(MachinePressScreen.TEXTURE, 26, 11, 124, 62).addPadding(0, 0, 16, 24).build();
    this.name = (Component)StringHelper.getTextComponent(((Block)ThermalCore.BLOCKS.get("machine_press")).m_7705_());
    this.progressBackground = Drawables.getDrawables(guiHelper).getProgress(0);
    this.progressFluidBackground = Drawables.getDrawables(guiHelper).getProgressFill(1);
    this.speedBackground = Drawables.getDrawables(guiHelper).getScale(2);
    this.tankBackground = Drawables.getDrawables(guiHelper).getTank(1);
    this.tankOverlay = Drawables.getDrawables(guiHelper).getTankOverlay(1);
    this.progress = guiHelper.createAnimatedDrawable(Drawables.getDrawables(guiHelper).getProgressFill(0), 200, IDrawableAnimated.StartDirection.LEFT, false);
    this.progressFluid = guiHelper.createAnimatedDrawable(Drawables.getDrawables(guiHelper).getProgress(1), 200, IDrawableAnimated.StartDirection.LEFT, true);
    this.speed = guiHelper.createAnimatedDrawable(Drawables.getDrawables(guiHelper).getScaleFill(2), 400, IDrawableAnimated.StartDirection.TOP, true);
  }
  
  public Class<? extends PressRecipe> getRecipeClass() {
    return PressRecipe.class;
  }
  
  public void setRecipe(IRecipeLayoutBuilder builder, PressRecipe recipe, IFocusGroup focuses) {
    List<Ingredient> inputs = recipe.getInputItems();
    List<ItemStack> outputs = new ArrayList<>(recipe.getOutputItems().size());
    List<FluidStack> outputFluids = recipe.getOutputFluids();
    for (ItemStack stack : recipe.getOutputItems())
      outputs.add(ItemHelper.cloneStack(stack)); 
    for (int i = 0; i < outputs.size(); i++) {
      float chance = ((Float)recipe.getOutputItemChances().get(i)).floatValue();
      if (chance > 1.0F)
        ((ItemStack)outputs.get(i)).m_41764_((int)chance); 
    } 
    builder.addSlot(RecipeIngredientRole.INPUT, 43, 6)
      .addIngredients(inputs.get(0));
    builder.addSlot(RecipeIngredientRole.INPUT, 43, 42)
      .addIngredients((inputs.size() < 2) ? Ingredient.f_43901_ : inputs.get(1));
    IRecipeSlotBuilder outputSlot = builder.addSlot(RecipeIngredientRole.OUTPUT, 106, 24);
    if (!outputs.isEmpty())
      ((IRecipeSlotBuilder)outputSlot.addItemStack(outputs.get(0)))
        .addTooltipCallback(TCoreJeiPlugin.defaultOutputTooltip(((Float)recipe.getOutputItemChances().get(0)).floatValue())); 
    ((IRecipeSlotBuilder)builder.addSlot(RecipeIngredientRole.OUTPUT, 141, 11)
      .addIngredients((IIngredientType)ForgeTypes.FLUID_STACK, outputFluids.isEmpty() ? Collections.emptyList() : List.<FluidStack>of(outputFluids.get(0))))
      .setFluidRenderer(TCoreJeiPlugin.tankSize(4000), false, 16, 40)
      .setOverlay((IDrawable)this.tankOverlay, 0, 0)
      .addTooltipCallback(TCoreJeiPlugin.defaultFluidTooltip());
  }
  
  public void draw(PressRecipe recipe, IRecipeSlotsView recipeSlotsView, PoseStack matrixStack, double mouseX, double mouseY) {
    super.draw((ThermalRecipe)recipe, recipeSlotsView, matrixStack, mouseX, mouseY);
    this.progressBackground.draw(matrixStack, 69, 24);
    this.tankBackground.draw(matrixStack, 140, 10);
    this.speedBackground.draw(matrixStack, 43, 24);
    if (!recipe.getOutputFluids().isEmpty()) {
      RenderHelper.drawFluid(matrixStack, 69, 24, recipe.getOutputFluids().get(0), 24, 16);
      this.progressFluidBackground.draw(matrixStack, 69, 24);
      this.progressFluid.draw(matrixStack, 69, 24);
    } else {
      this.progress.draw(matrixStack, 69, 24);
    } 
    this.speed.draw(matrixStack, 43, 24);
  }
}
